// SampleVC.NETDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleVC.NET.h"
#include "SampleVC.NETDlg.h"

#include "LEPCLIB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSampleVCNETDlg dialog




CSampleVCNETDlg::CSampleVCNETDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleVCNETDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleVCNETDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CONNECT, m_cntCONNECT);
	DDX_Control(pDX, IDC_RUN, m_cntRUN);
}

BEGIN_MESSAGE_MAP(CSampleVCNETDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CONNECT, &CSampleVCNETDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_RUN, &CSampleVCNETDlg::OnBnClickedRun)
	ON_BN_CLICKED(IDC_KEY0, &CSampleVCNETDlg::OnBnClickedKey0)
	ON_BN_CLICKED(IDC_KEY1, &CSampleVCNETDlg::OnBnClickedKey1)
	ON_BN_CLICKED(IDC_KEY2, &CSampleVCNETDlg::OnBnClickedKey2)
	ON_BN_CLICKED(IDC_GETMONITOR, &CSampleVCNETDlg::OnBnClickedGetmonitor)
END_MESSAGE_MAP()


// CSampleVCNETDlg message handlers

BOOL CSampleVCNETDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleVCNETDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleVCNETDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSampleVCNETDlg::OnBnClickedConnect()
{
	int err;
	if( m_cntCONNECT.GetCheck() ){
		err = LEConnect("COM1");
		if( err == LE_FAIL ){
			MessageBox(_T("connect error"));
			m_cntCONNECT.SetCheck(FALSE);
		}
	} else {
		LEDisconnect();
	}
}

void CSampleVCNETDlg::OnBnClickedRun()
{
	int err;
	if( m_cntRUN.GetCheck() ){
		err = LEStartMeasure();
		if( err == LE_FAIL ){
			MessageBox(_T("run error"));
			m_cntRUN.SetCheck(FALSE);
		}
	} else {
		LEStopMeasure();
	}
}

void CSampleVCNETDlg::OnBnClickedKey0()
{
	LEEmulationKey(LE_REMOTE_KEY_0);
}

void CSampleVCNETDlg::OnBnClickedKey1()
{
	LEEmulationKey(LE_REMOTE_KEY_1);
}

void CSampleVCNETDlg::OnBnClickedKey2()
{
	LEEmulationKey(LE_REMOTE_KEY_2);
}

void CSampleVCNETDlg::OnBnClickedGetmonitor()
{
	DWORD size = 4096;

	int err;
	LE_MONDATA *mondata = new LE_MONDATA[size];
	err = LEGetMonitorData(mondata, &size);
	if( err == LE_FAIL ){
		MessageBox(_T("get error"));
		delete[] mondata;
		return;
	}

	CFileDialog dlg (FALSE, _T(".csv"), _T("MONDATA.CSV"), NULL, _T("CSV(*.csv)|*.csv|All(*.*)|*.*||"));
	if( dlg.DoModal() == IDOK ){
		CString filename;
		CFile file;
		filename = dlg.GetPathName();
		if( file.Open(filename, CFile::modeCreate | CFile::modeWrite) == 0 ){
			MessageBox(_T("open error"));
			delete[] mondata;
			return;
		}
		for( DWORD i = 0; i < size; i ++ ){
			char str[10],strSD[10],strRD[10];
			sprintf(strSD, "%02X", mondata[i].SD);
			sprintf(strRD, "%02X", mondata[i].RD);
			if( !(mondata[i].statusSD & LE_MONSTATUS_DATA_VISIBLE) ){
				strcpy( strSD, "--" );
			}
			if( !(mondata[i].statusRD & LE_MONSTATUS_DATA_VISIBLE) ){
				strcpy( strRD, "--" );
			}

			sprintf(str,"%s,%s\r\n", strSD, strRD);
			file.Write(str, strlen(str));
		}
		file.Close();
		MessageBox(_T("success"));
	}

	delete[] mondata;
}
